#include <bits/stdc++.h>

#define int long long
using namespace std;

struct segtree {
    struct node {
        int mod;
        int val;
        int cnt;
        int mn;
    };
    int size;
    vector<node> tree;

    node combine(node a, node b) {
        if (a.mn == b.mn) {
            return {0, a.val + b.val, a.cnt + b.cnt, a.mn};
        } else if (a.mn < b.mn) {
            return {0, a.val + b.val, a.cnt, a.mn};
        } else {
            return {0, a.val + b.val, b.cnt, b.mn};
        }
    }

    void build(int v, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            if (l < a.size()) {
                tree[v].val = a[l];
                tree[v].mn = 0;
                tree[v].cnt = tree[v].val;
            }
            return;
        }
        int mid = (l + r) / 2;
        build(2 * v + 1, l, mid, a);
        build(2 * v + 2, mid, r, a);
        tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
    }

    void init(int n, vector<int> &a) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.assign(2 * size - 1, {0, 0, 0, INT_MAX});
        build(0, 0, size, a);
    }

    void push(int v, int l, int r) {
        if (r - l == 1 || tree[v].mod == 0) {
            return;
        }
        tree[2 * v + 1].mod += tree[v].mod;
        tree[2 * v + 2].mod += tree[v].mod;
        tree[2 * v + 1].mn += tree[v].mod;
        tree[2 * v + 2].mn += tree[v].mod;
        tree[v].mod = 0;
    }

    void add(int v, int l, int r, int ql, int qr, int mod) {
        push(v, l, r);
        if (l >= ql && qr >= r) {
            tree[v].mod += mod;
            tree[v].mn += mod;
            return;
        }
        if (ql >= r || l >= qr) {
            return;
        }
        int mid = (l + r) / 2;
        add(2 * v + 1, l, mid, ql, qr, mod);
        add(2 * v + 2, mid, r, ql, qr, mod);
        tree[v] = combine(tree[2 * v + 1], tree[2 * v + 2]);
    }
};

struct pr {
    int x1, y1, x2, y2;
};
struct seg {
    int y1, y2, x, type;
};

bool cmp(seg a, seg b) {
    if (a.x != b.x) {
        return a.x < b.x;
    }
    return a.type < b.type;
}

signed main() {
    int k, n;
    cin >> k >> n;
    int x1 = 0;
    int y1 = 0;
    int x2 = k;
    int y2 = k;
    vector<pr> a;
    for (int i = 0; i < n; ++i) {
        char ch;
        int x;
        cin >> ch >> x;
        if (ch == 'N') {
            a.push_back({x1, y1, x2, y2 + x});
            y2 += x;
            y1 += x;
        } else if (ch == 'S') {
            a.push_back({x1, y1 - x, x2, y2});
            y1 -= x;
            y2 -= x;
        } else if (ch == 'W') {
            a.push_back({x1 - x, y1, x2, y2});
            x1 -= x;
            x2 -= x;
        } else {
            a.push_back({x1, y1, x2 + x, y2});
            x2 += x;
            x1 += x;
        }
    }
    set<int> z;
    vector<seg> segs;
    map<int, vector<pair<int, int>>> f;
    for (int i = 0; i < a.size(); ++i) {
        z.insert(a[i].y1);
        z.insert(a[i].y2);
        segs.push_back({a[i].y1, a[i].y2, a[i].x1, -1});
        segs.push_back({a[i].y1, a[i].y2, a[i].x2, 1});
    }
    bool e = true;
    int u;
    vector<int> val;
    map<int, int> mp;
    for (int to: z) {
        if (e) {
            e = false;
            u = to;
            mp[to] = 0;
            continue;
        }
        val.push_back(to - u);
        mp[to] = val.size();
        u = to;
    }
    segtree st;
    st.init(val.size() + 1, val);
    sort(segs.begin(), segs.end(), cmp);
    int sum = st.tree[0].val;
    int ans = 0;
    for (int i = 0; i < segs.size(); ++i) {
        if (!i) {
            st.add(0, 0, st.size, mp[segs[i].y1], mp[segs[i].y2], 1);
        } else {
            if (st.tree[0].mn == 0) {
                ans += (sum - st.tree[0].cnt) * (segs[i].x - segs[i - 1].x);
            } else {
                ans += sum * (segs[i].x - segs[i - 1].x);
            }
            if (segs[i].type == 1) {
                st.add(0, 0, st.size, mp[segs[i].y1], mp[segs[i].y2], -1);
            } else {
                st.add(0, 0, st.size, mp[segs[i].y1], mp[segs[i].y2], 1);
            }
        }

    }
    cout << ans;
}
/*
 3 4
W 2
N 1
W 1
N 2

 1 5
E 2
N 2
W 4
S 4
E 4
 */